gtkmm: Gtk::CellRendererProgress Class Reference

gtkmm 4.14.0

Public Member Functions | Static Public Member Functions | Related Symbols | List of all members
Gtk::CellRendererProgress Class Reference
TreeView Classes

Renders numbers as progress bars. More...

`#include <gtkmm/cellrendererprogress.h>`

Inheritance diagram for Gtk::CellRendererProgress:
[legend]

## Public Member Functions
| CellRendererProgress (CellRendererProgress &&src) noexcept
CellRendererProgress & | operator= (CellRendererProgress &&src) noexcept
| CellRendererProgress (const CellRendererProgress &)=delete
CellRendererProgress & | operator= (const CellRendererProgress &)=delete
| ~CellRendererProgress () noexcept override
GtkCellRendererProgress * | gobj ()
| Provides access to the underlying C GObject.
const GtkCellRendererProgress * | gobj () const
| Provides access to the underlying C GObject.
| CellRendererProgress ()
Glib::PropertyProxy< int > | property_value ()
| The "value" property determines the percentage to which the progress bar will be "filled in".
Glib::PropertyProxy_ReadOnly< int > | property_value () const
| The "value" property determines the percentage to which the progress bar will be "filled in".
Glib::PropertyProxy< Glib::ustring > | property_text ()
| The "text" property determines the label which will be drawn over the progress bar.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_text () const
| The "text" property determines the label which will be drawn over the progress bar.
Glib::PropertyProxy< int > | property_pulse ()
| Setting this to a non-negative value causes the cell renderer to enter "activity mode", where a block bounces back and forth to indicate that some progress is made, without specifying exactly how much.
Glib::PropertyProxy_ReadOnly< int > | property_pulse () const
| Setting this to a non-negative value causes the cell renderer to enter "activity mode", where a block bounces back and forth to indicate that some progress is made, without specifying exactly how much.
Glib::PropertyProxy< float > | property_text_xalign ()
| The "text-xalign" property controls the horizontal alignment of the text in the progress bar.
Glib::PropertyProxy_ReadOnly< float > | property_text_xalign () const
| The "text-xalign" property controls the horizontal alignment of the text in the progress bar.
Glib::PropertyProxy< float > | property_text_yalign ()
| The "text-yalign" property controls the vertical alignment of the text in the progress bar.
Glib::PropertyProxy_ReadOnly< float > | property_text_yalign () const
| The "text-yalign" property controls the vertical alignment of the text in the progress bar.
Glib::PropertyProxy< bool > | property_inverted ()
| Default value: `false`
Glib::PropertyProxy_ReadOnly< bool > | property_inverted () const
| Default value: `false`
Public Member Functions inherited from Gtk::CellRenderer
| CellRenderer (CellRenderer &&src) noexcept
CellRenderer & | operator= (CellRenderer &&src) noexcept
| CellRenderer (const CellRenderer &)=delete
CellRenderer & | operator= (const CellRenderer &)=delete
| ~CellRenderer () noexcept override
GtkCellRenderer * | gobj ()
| Provides access to the underlying C GObject.
const GtkCellRenderer * | gobj () const
| Provides access to the underlying C GObject.
SizeRequestMode | get_request_mode () const
| Gets whether the cell renderer prefers a height-for-width layout or a width-for-height layout.
void | get_preferred_width (Widget &widget, int &minimum_width, int &natural_width) const
| Retrieves a renderer’s natural size when rendered to widget.
void | get_preferred_height_for_width (Widget &widget, int width, int &minimum_height, int &natural_height) const
| Retrieves a cell renderers’s minimum and natural height if it were rendered to widget with the specified width.
void | get_preferred_height (Widget &widget, int &minimum_height, int &natural_height) const
| Retrieves a renderer’s natural size when rendered to widget.
void | get_preferred_width_for_height (Widget &widget, int height, int &minimum_width, int &natural_width) const
| Retrieves a cell renderers’s minimum and natural width if it were rendered to widget with the specified height.
void | get_preferred_size (Widget &widget, Requisition &minimum_size, Requisition &natural_size) const
| Retrieves the minimum and natural size of a cell taking into account the widget’s preference for height-for-width management.
Gdk::Rectangle | get_aligned_area (Widget &widget, CellRendererState flags, const Gdk::Rectangle &cell_area) const
| Gets the aligned area used by this CellRenderer inside cell_area.
void | snapshot (const Glib::RefPtr< Gtk::Snapshot > & snapshot, Widget &widget, const Gdk::Rectangle &background_area, const Gdk::Rectangle &cell_area, CellRendererState flags)
| Invokes the virtual render function of the `Gtk::CellRenderer`.
bool | activate (const Glib::RefPtr< const Gdk::Event > & event, Widget &widget, const Glib::ustring & path, const Gdk::Rectangle &background_area, const Gdk::Rectangle &cell_area, CellRendererState flags)
| Passes an activate event to the cell renderer for possible processing.
CellEditable * | start_editing (const Glib::RefPtr< const Gdk::Event > & event, Widget &widget, const Glib::ustring & path, const Gdk::Rectangle &background_area, const Gdk::Rectangle &cell_area, CellRendererState flags=CellRendererState(0))
| Starts editing the contents of this cell, through a new `Gtk::CellEditable` widget created by the `Gtk::CellRenderer`Class.start_editing virtual function.
void | set_fixed_size (int width, int height)
| Sets the renderer size to be explicit, independent of the properties set.
void | get_fixed_size (int & width, int &height) const
| Fills in width and height with the appropriate size of cell.
void | set_alignment (float xalign, float yalign)
| Sets the renderer’s alignment within its available space.
void | get_alignment (float &xalign, float &yalign) const
| Fills in xalign and yalign with the appropriate values of cell.
void | set_padding (int xpad, int ypad)
| Sets the renderer’s padding.
void | get_padding (int &xpad, int &ypad) const
| Fills in xpad and ypad with the appropriate values of cell.
void | set_visible (bool visible=true)
| Sets the cell renderer’s visibility.
bool | get_visible () const
| Returns the cell renderer’s visibility.
void | set_sensitive (bool sensitive=true)
| Sets the cell renderer’s sensitivity.
bool | get_sensitive () const
| Returns the cell renderer’s sensitivity.
bool | is_activatable () const
| Checks whether the cell renderer can do something when activated.
void | set_is_expander (bool is_expander=true)
| Sets whether the given `Gtk::CellRenderer` is an expander.
bool | get_is_expander () const
| Checks whether the given `Gtk::CellRenderer` is an expander.
void | set_is_expanded (bool is_expanded=true)
| Sets whether the given `Gtk::CellRenderer` is expanded.
bool | get_is_expanded () const
| Checks whether the given `Gtk::CellRenderer` is expanded.
void | stop_editing (bool canceled=false)
| Informs the cell renderer that the editing is stopped.
StateFlags | get_state (Widget &widget, CellRendererState cell_state) const
| Translates the cell renderer state to `Gtk::StateFlags`, based on the cell renderer and widget sensitivity, and the given `Gtk::CellRenderer`State.
StateFlags | get_state (CellRendererState cell_state) const
| A get_state() convenience overload.
Glib::SignalProxy< void()> | signal_editing_canceled ()
Glib::PropertyProxy< CellRendererMode > | property_mode ()
| Default value: Gtk::CellRendererMode::INERT.
Glib::PropertyProxy_ReadOnly< CellRendererMode > | property_mode () const
| Default value: Gtk::CellRendererMode::INERT.
Glib::PropertyProxy< bool > | property_visible ()
| Default value: `true`
Glib::PropertyProxy_ReadOnly< bool > | property_visible () const
| Default value: `true`
Glib::PropertyProxy< bool > | property_sensitive ()
| Default value: `true`
Glib::PropertyProxy_ReadOnly< bool > | property_sensitive () const
| Default value: `true`
Glib::PropertyProxy< float > | property_xalign ()
| Default value: 0.5.
Glib::PropertyProxy_ReadOnly< float > | property_xalign () const
| Default value: 0.5.
Glib::PropertyProxy< float > | property_yalign ()
| Default value: 0.5.
Glib::PropertyProxy_ReadOnly< float > | property_yalign () const
| Default value: 0.5.
Glib::PropertyProxy< unsigned int > | property_xpad ()
| Default value: 0.
Glib::PropertyProxy_ReadOnly< unsigned int > | property_xpad () const
| Default value: 0.
Glib::PropertyProxy< unsigned int > | property_ypad ()
| Default value: 0.
Glib::PropertyProxy_ReadOnly< unsigned int > | property_ypad () const
| Default value: 0.
Glib::PropertyProxy< int > | property_width ()
| Default value: -1.
Glib::PropertyProxy_ReadOnly< int > | property_width () const
| Default value: -1.
Glib::PropertyProxy< int > | property_height ()
| Default value: -1.
Glib::PropertyProxy_ReadOnly< int > | property_height () const
| Default value: -1.
Glib::PropertyProxy< bool > | property_is_expander ()
| Default value: `false`
Glib::PropertyProxy_ReadOnly< bool > | property_is_expander () const
| Default value: `false`
Glib::PropertyProxy< bool > | property_is_expanded ()
| Default value: `false`
Glib::PropertyProxy_ReadOnly< bool > | property_is_expanded () const
| Default value: `false`
Glib::PropertyProxy_WriteOnly< Glib::ustring > | property_cell_background ()
| Default value: "".
Glib::PropertyProxy< Gdk::RGBA > | property_cell_background_rgba ()
| Cell background as a `GdkRGBA`
Glib::PropertyProxy_ReadOnly< Gdk::RGBA > | property_cell_background_rgba () const
| Cell background as a `GdkRGBA`
Glib::PropertyProxy< bool > | property_cell_background_set ()
| Default value: `false`
Glib::PropertyProxy_ReadOnly< bool > | property_cell_background_set () const
| Default value: `false`
Glib::PropertyProxy_ReadOnly< bool > | property_editing () const
| Default value: `false`
Public Member Functions inherited from Gtk::Object
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
| ~Object () noexcept override
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from Gtk::Orientable
| Orientable (Orientable &&src) noexcept
Orientable & | operator= (Orientable &&src) noexcept
| ~Orientable () noexcept override
GtkOrientable * | gobj ()
| Provides access to the underlying C GObject.
const GtkOrientable * | gobj () const
| Provides access to the underlying C GObject.
void | set_orientation (Orientation orientation)
| Sets the orientation of the orientable.
Orientation | get_orientation () const
| Retrieves the orientation of the orientable.
Glib::PropertyProxy< Orientation > | property_orientation ()
| The orientation of the orientable.
Glib::PropertyProxy_ReadOnly< Orientation > | property_orientation () const
| The orientation of the orientable.
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::CellRenderer
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::Orientable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Related Symbols
(Note that these are not member symbols.)
Gtk::CellRendererProgress * | wrap (GtkCellRendererProgress *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::CellRenderer
Gtk::CellRenderer * | wrap (GtkCellRenderer *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Orientable
Glib::RefPtr< Gtk::Orientable > | wrap (GtkOrientable *object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Attributes inherited from Gtk::CellRenderer
Glib::SignalProxy< void(CellEditable *, const Glib::ustring &) | signal_editing_started )()
Protected Member Functions inherited from Gtk::CellRenderer
| CellRenderer ()
virtual SizeRequestMode | get_request_mode_vfunc () const
virtual void | get_preferred_width_vfunc (Widget &widget, int &minimum_width, int &natural_width) const
virtual void | get_preferred_height_for_width_vfunc (Widget &widget, int width, int &minimum_height, int &natural_height) const
virtual void | get_preferred_height_vfunc (Widget &widget, int &minimum_height, int &natural_height) const
virtual void | get_preferred_width_for_height_vfunc (Widget &widget, int height, int &minimum_width, int &natural_width) const
virtual void | snapshot_vfunc (const Glib::RefPtr< Gtk::Snapshot > &snapshot, Widget &widget, const Gdk::Rectangle &background_area, const Gdk::Rectangle &cell_area, CellRendererState flags)
virtual bool | activate_vfunc (const Glib::RefPtr< const Gdk::Event > & event, Widget &widget, const Glib::ustring & path, const Gdk::Rectangle &background_area, const Gdk::Rectangle &cell_area, CellRendererState flags)
virtual CellEditable * | start_editing_vfunc (const Glib::RefPtr< const Gdk::Event > & event, Widget &widget, const Glib::ustring & path, const Gdk::Rectangle &background_area, const Gdk::Rectangle &cell_area, CellRendererState flags)
virtual void | on_editing_canceled ()
| This is a default handler for the signal signal_editing_canceled().
virtual void | on_editing_started (CellEditable * editable, const Glib::ustring & path)
| This is a default handler for the signal signal_editing_started().
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gtk::Orientable
| Orientable ()
| You should derive from this class to use it.

## Detailed Description

Renders numbers as progress bars.

Since gtkmm 2.6

Deprecated
  4.10: List views use widgets to display their contents. You should use Gtk::ProgressBar instead.

## Constructor & Destructor Documentation

## ◆ CellRendererProgress() [1/3]

Gtk::CellRendererProgress::CellRendererProgress | ( | CellRendererProgress && | src | ) |
| noexcept

## ◆ CellRendererProgress() [2/3]

Gtk::CellRendererProgress::CellRendererProgress | ( | const CellRendererProgress & |  | ) |
| delete

## ◆ ~CellRendererProgress()

Gtk::CellRendererProgress::~CellRendererProgress | ( |  | ) |
| overridenoexcept

## ◆ CellRendererProgress() [3/3]

Gtk::CellRendererProgress::CellRendererProgress | ( |  | ) |

## Member Function Documentation

## ◆ get_type()

static GType Gtk::CellRendererProgress::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkCellRendererProgress * Gtk::CellRendererProgress::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkCellRendererProgress * Gtk::CellRendererProgress::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ operator=() [1/2]

CellRendererProgress & Gtk::CellRendererProgress::operator= | ( | CellRendererProgress && | src | ) |
| noexcept

## ◆ operator=() [2/2]

CellRendererProgress & Gtk::CellRendererProgress::operator= | ( | const CellRendererProgress & |  | ) |
| delete

## ◆ property_inverted() [1/2]

Glib::PropertyProxy< bool > Gtk::CellRendererProgress::property_inverted | ( |  | ) |

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_inverted() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::CellRendererProgress::property_inverted | ( |  | ) | const

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_pulse() [1/2]

Glib::PropertyProxy< int > Gtk::CellRendererProgress::property_pulse | ( |  | ) |

Setting this to a non-negative value causes the cell renderer to enter "activity mode", where a block bounces back and forth to indicate that some progress is made, without specifying exactly how much.

Each increment of the property causes the block to move by a little bit.

To indicate that the activity has not started yet, set the property to zero. To indicate completion, set the property to G_MAXINT.

Default value: -1

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_pulse() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::CellRendererProgress::property_pulse | ( |  | ) | const

Setting this to a non-negative value causes the cell renderer to enter "activity mode", where a block bounces back and forth to indicate that some progress is made, without specifying exactly how much.

Each increment of the property causes the block to move by a little bit.

To indicate that the activity has not started yet, set the property to zero. To indicate completion, set the property to G_MAXINT.

Default value: -1

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_text() [1/2]

Glib::PropertyProxy< Glib::ustring > Gtk::CellRendererProgress::property_text | ( |  | ) |

The "text" property determines the label which will be drawn over the progress bar.

Setting this property to `nullptr` causes the default label to be displayed. Setting this property to an empty string causes no label to be displayed.

Default value: ""

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_text() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::CellRendererProgress::property_text | ( |  | ) | const

The "text" property determines the label which will be drawn over the progress bar.

Setting this property to `nullptr` causes the default label to be displayed. Setting this property to an empty string causes no label to be displayed.

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_text_xalign() [1/2]

Glib::PropertyProxy< float > Gtk::CellRendererProgress::property_text_xalign | ( |  | ) |

The "text-xalign" property controls the horizontal alignment of the text in the progress bar.

Valid values range from 0 (left) to 1 (right). Reserved for RTL layouts.

Default value: 0.5

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_text_xalign() [2/2]

Glib::PropertyProxy_ReadOnly< float > Gtk::CellRendererProgress::property_text_xalign | ( |  | ) | const

The "text-xalign" property controls the horizontal alignment of the text in the progress bar.

Valid values range from 0 (left) to 1 (right). Reserved for RTL layouts.

Default value: 0.5

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_text_yalign() [1/2]

Glib::PropertyProxy< float > Gtk::CellRendererProgress::property_text_yalign | ( |  | ) |

The "text-yalign" property controls the vertical alignment of the text in the progress bar.

Valid values range from 0 (top) to 1 (bottom).

Default value: 0.5

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_text_yalign() [2/2]

Glib::PropertyProxy_ReadOnly< float > Gtk::CellRendererProgress::property_text_yalign | ( |  | ) | const

The "text-yalign" property controls the vertical alignment of the text in the progress bar.

Valid values range from 0 (top) to 1 (bottom).

Default value: 0.5

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_value() [1/2]

Glib::PropertyProxy< int > Gtk::CellRendererProgress::property_value | ( |  | ) |

The "value" property determines the percentage to which the progress bar will be "filled in".

Default value: 0

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_value() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::CellRendererProgress::property_value | ( |  | ) | const

The "value" property determines the percentage to which the progress bar will be "filled in".

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## Friends And Related Symbol Documentation

## ◆ wrap()

Gtk::CellRendererProgress * wrap | ( | GtkCellRendererProgress * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.